AIPLANET Change History
-----------------------------------

1.0.0

Official Release
Added Artificial Planet Manual by Dennis Murczak
Added Code Structure Documents (Pasdoc/Aaron)
Fixed targeting arrow keys
New land textures (Dennis)
Upgraded texture seams and blending
Identical textures on world load
Added optimizations to Positioning (still room for more opt)
Optimized planet texture changing
Added Advanced Mode in Settings (hides AI/collisions)
Set trees to reproduce only within XY radius (thins them out)
Fixed camera at poles (not sane, but less crazy)

0.9.9

Set internal water system to more closely match visual water system
Fixed fullscreen camera bar hiding
Fixed populations form bug
Fixed populations lines to become fixed length over time
Fixed FireTrees (new model, casted long shadow)
Fixed Seeds (new model, now cast shadow)
Set water tool default to 1
Fixed vInterface "camEyes" text (was blank)
Sped up Keyboard checking
Sped up AIPosition.Fuel
Set Populations default Refresh Rate to 4, Crop to 1024
Added WaterMax and LandMax to AIGrid
Added precalculated X*10 and Y*10 to AICoordinates
Tweaked terrain collision
Revamped NSIS installer (no more quicklaunch)

0.9.8

Added AIMissileDefence and AIMissile
-Detects and destroys incoming asteroids
Major interface cleanup:
-Added Disasters menu
-Moved Cameras to bottom
-Rearranged and polished buttons
-Made buttons bigger
-Moved shadows to visuals toolbar
Fixed blinking mouse pick
Fixed Tfm3DEnvironment.FindTarget(aThing: AIThing);
Fixed LastTool after Reality Stop/Start
Fixed Intangible objects making splash noise
Added Random Asteroids setting in Set Menu
Added "Next Kind" targetting camera button

0.9.7

Added option to disable creation of FireFX
Fixed Starfield bug
Fixed "Vicious Circle" of Lightning 
Fixed AVI Recording bug
Added new AVIDirect and AVIFrame buttons to control moviemaking
Added some hints and tips

0.9.6

Added Speech (AISpeech, text bubbles in 3D View)
Added Camera Eyes (first person perspective of your target)
Added AIFireTrees (to simulate a forest fire)
Added AVIRecorder (makes AVI movies, no sound)
Added HighPoly fruits and High Detail button to Audio menu
Updated Purgatory system with new Trash system
Added Plant Removal cursor
Added Life.Die cursor
Added Thing removal cursor
Added AIThingList.Tangibles
Fixed Cease bug
Fixed AnyBeacon divided by 0
Fixed non-existing objects getting fueled
Added Lightning Button
Added Rain Cloud Button
Modified Storm Cloud to no rain
Added Restore button (restores time and space window)
Added Harm button (-256 health)
Fixed old apple tree model (appletree.3ds)
Modified AIBall.Fuel -> added Position.TurnTowardsVelocity
Added some new icons (jump, multicast, storm, lightning, etc)
Fixed MouseInfo leave-behind HUDText bug
Set Atmosphere default to On
Fixed Asteroid model positioning
Stopped close zoom from going to Avatar mode (was annoying)
Added AIThing.Report

0.9.5.d

Camera goes to next target of kind if target dies
Sharks attack ducks
Fixed: object selection with multicast shadows
Fixed: Lists form starts with autorefresh off
Added: Volume Control via Sound menu (delayed)
Moved track and predict trails to Sound menu
Added AnyBeacon to Tools menu (a beacon to produce any thing)

0.9.5.c

Improved error form
Fixed free floating camera crash bug (some uncommon inconsistencies remain)
Updated Show Cursor button functionality
Updated Atmosphere button functionality
Many small user interface improvements and tweaks

0.9.5.b

Added Shadows (thanks Philipp and mrqzz)
Added GraphicsEdge Tip of the Day, from GLData CVS (thanks Aaron)
Tweaked AIBeacon.PopThing
Fixed fruit->seed collision problem
Added Remember 3D View settings to User Registry settings
Fixed hole in duck model (thanks Halobear)
Updated Grazers (now mating community creatures)
Added email reporting to fError.pas
Improved Error Reporting
Instinctive - Ocean of Freedom.mp3
Nils Schneider - Strange Behaviour.mp3
New birds models (reversed wing faces for shadows)
New tree models (reversed leaf faces for shadows)
New hawk model (reversed wing faces for shadows)
Added Multicast shadows option to Visuals toolbar
Added Shadow volumes option to Visuals toolbar

0.9.5.a

Added collision detection and response (AIThings.CheckCollisions)
Added kinetic energy to collisions
Added AIThing.OnCollide; virtual 
Added AIOrbiter.OnCollide; override -> Explode
Suns and moons can collide and explode
Disabled photograph graphic (alot faster)
Added AICloud.Perform (lightning, etc)
Increased explosion damage
Added Error handling form
Removed JVL Tip of the Day (caused major crashes)

0.9.4

Added multicolored trees/fruits/seeds
Modified AI code to search for more fruits (birds, fish etc)
Added AIEvolvingTree
Added AIEvolvingFruit
Added AIEvolvingSeed
Added TGLColorProxyObject to GLScene
Added Color to DNA
Added BreakLimits to f3DEnvironment (allows user to go beyond max)
Added Repeat button
Added ladybug and ant tracking buttons
Added DNA.SaveToINI
Added Go/Stop label to Application.Title
Added AIThingList.Fruits // list of all fruits
Added AIThingList.Prey // list of all prey
Added AIThingList.Predators // list of all predators
Added AIThing.IsFruit
Added AIThing.IsPrey
Added AIThing.IsPredator
Improved AI of many creatures
Added ReloadBaseDNAs (reloads all the base DNA files)
Modified AquaPlants to have a FruitTimer (random on create)
Added AIForce.Alter methods
Improved Bird Mating
Fixed Hawks
Made Foxes and Rabbits into AIGeneticCreatures
Added AIMatingSingle (mating creature without community)
Added Jump button
Added object control keys when in target mode
Added camera move keys when in target mode
Set maximum force to 5 instead of 10 (fixes ultrafast bug)
Added mouse control of objects velocity (Tool = tMove)
Added RefreshRate and Crop edit boxes to Populations form
Removed camTrack and camFind modes
Set New planets to Go mode
Disabled Middle Button function to change target (for older mice)

0.9.3

Added Ladybug.ini DNA text file (Thanks Dushan)
Added Fox.ini and Rabbit.ini (Dushan Tcholich)
Added Tip of the Day (thanks Aaron)
Added fPosition.pas: A form to edit any objects position
Added fDNA.pas: A form to edit any GeneticCreature DNA
Added Bounce to Ladybug DNA
Added Position and DNA buttons to fSpirit.pas
Fixed Load bug (due to turning off sun at startup!)
Added AIFlock.FullDisplay
Added AIDNA.LoadFromINI
Added AIThingList.Forms/GenerateForms (DNA defaults)
Added data/tips.txt (tips of the day file)
Fixed AIDNA.FullDisplay
Fixed bird flocking bug (AILivingGroups now inserted at start of list)
Turned off sun at startup
Added an integer-only editor to the Maximums form

0.9.2

Made LadyBug inherited from AIGeneticCreature (evolves buoyancy)
Added Mating Timer (128)
Fixed Mating direction bug for Males
Added Handle to all relevant OneLineDisplays
cAIActions.pas: Action Scheduler now active (disabled due to bug)
Added PositionThing // solves flat vs sphere coordinates
Fixed Camera.NearPlaneBias
Added Free Camera mode
Fixed AIBird.ReaffirmFlock
Added duplicate member check to AILivingGroup.AddMember
Made EventScheduler more robust and memory efficient (now a dynamic array)
Disabled auto-mouseview when reality is stopped
Fixed Tool selection after loading file
Dozens more minor changes/fixes/tweaks

0.9.1h

Fixed: AICommunityCreature.Community rejoin (thanks Dushan Tcholich)
Stopped reality on Load
Added: AIThingList.JoinAllCommunities;
Added: AIBird.ReaffirmFlock;
Added: AICommunityCreature.ReaffirmCommunity;
Added: AIEnvironment.LoadFromFile -> fThings.JoinAllCommunities;
Improved Buoyancy (objects no longer bounce on top of water)
Tweaked the water bubble a bit, made it larger (works perfect in Flat Mode)
Disabled Minimize on fPopulations
Disabled Minimize on fHeightField
Disabled Minimize on fHumidityMap
Disabled Minimize on fSpirit
Disabled Minimize on fConstruction

0.9.1g

Added Earthquakes (Dave and Aaron)
Added an optional Camera Light (improves look greatly) // default is on for now
Call RefreshSatellites when user pops SpaceForm (fixes improper world state flash bug)
Call EmptyAllSounds when user pops SpaceForm (fixes buildup of sounds played all at once)
Fixed bug: AIAttachmentContainer.SetObjectPointers
Fixed: AILearningCreature.SaveToFile, LoadFromFile // wasnt calling inherited method
Fixed: AICommunity.SaveToFile, LoadFromFile
Fixed: AICommunityCreature.SaveToFile, LoadFromFile
Fixed: AIMatingCreature.SaveToFile, LoadFromFile
cUtilities: added writeVector and readVector // file read/write methods

0.9.1f

When user stops reality, the active tool is set to Select
Added f3DEnvironment.InformOfStart
Added f3DEnvironment.InformOfStop
When Reality stops and starts, calls either method
Added numbers to Populations Graph
Added ThingNamePlural in AIThings.pas
Tidied up the Time/Reality bar
Set the default SpaceForm size to be no more than 1024x768 on startup
Fake Sun button now positions sun in center of map, and stops it automatically
New Planet form defaults to no continents, land, or sun

0.9.1e

Removed SafeBonk and SafeGrab (may have permanently fixed Attachment.Holding bug)

0.9.1d

Added baby duck sound
Added zoom in/out buttons
Fixed photo/autosnap directory bug
Moved cbTrackNewThings to Tools menu
Caught a nasty bug: not saving gUniqueHandle to files
Target dead in object windows fixed (gUniqueHandle bug)
Added memory dump buttons to fLists
Cleaned up fLists
Began cleaning up AIThings.pas; removing NewThing functions
Improved Populations Graph cropping algorithm
Set Mating gender to random(2) male/female

0.9.1c

-Turtle AI Improved (no longer superhungry)
-Duck Flocking improved
-Added AIThing.Digest, returns a result for eating
-Changed AICreature.Grab and CloseEnoughToGrab (better)
-Trees, seeds, aquaplants, explosions, lightning return negative Digest value
-Added LimitVector to cUtilities
-Changed some Mating.Stage constant values
-Fixed AIReportCard.LoadFromFile (turtles and crabs now load correctly)
-Fixed birds not able to grab apples on ground
-Bug fixed: POPULATIONS GRAPH FIXED!!! :)
-Added hidden refresh option to Populations Graph
-Added $Id: changes.txt,v 1.76 2003/10/01 06:48:24 aidave Exp $ to top of most files (thanks Aaron)
-Set Hawk model normals to Inverted (was inside out)
-Increased Hawk turning rate
-Bug found: photos/autosnap, directory changes if loaded/saved a world
-Changed trees to not drop seed when dead
-Added Track button to Lists form

0.9.1b

-Fixed crabs jumping to catch airborne prey
-Fixed turtles to grab properly (warning they are dangerous!)
-Fixed settings form
-Updated selection icon

0.9.1a

-Modified AquaPlants to produce some Apples (for crabs on bottom of lake)
-Fixed AIMatingCreature.MateWithPartner 
  (creatures dont exhibit mating activity when flock is full)
-Added AIMatingCreature.DevelopIntoBaby, called when new baby
-Made Ducks surface from underwater faster
-Changed most FaceTargets to TurnTowardsTarget
-Added InvertMouseWheel to UserSettings
-Allowed closer zooming by setting GLCamera.FocalLength when Distance to target <1
-Made Crabs Learning (inherits from AILearningCreature)
-Made AILearningCreature
-Improved Creature.Grab, uses CloseEnoughToGrab function to more accurately 
  have the creature's grab be based on its size+distance to target
-Not working: AIReportCard.SaveToFile, .LoadFromFile
-Changed all function FullDisplay(..): string; to procedure FullDisplay(..);
  Wasnt passing a string back!
-Added Ants (Dave)
-Added LadyBug (Dave, Dan Bartlett, Nik)
-Added AIReportCard, AIReportList (learning memory structures)
-Added Learning to Turtles
-Fixed Maximums form to include last thing (was cLastThing - 1)
-Added WordWrap to Text Box in Object View
-Added SetFocus to OnMouseEnter (thx Aaron)
-Adjusted Targeting Camera rotation to be smoother
-Fixed Camera zoom mouse wheel, +/- keys
-Fixed Camera zoom with bots
-Fixed Target ToolButton bug (key / check for nil, button didnt)
-Added Duck Female model (raised tail, longer beak, sleeker body, lighter color)
-Darkened fish
-Turned MouseView on when reality is paused
-Added AutoSnap feature to take a small BMP picture every N ticks 
  (for making animated GIFs)

0.9.0
-Added Dolphins (Dave and Aaron)
-Added Fish mating (Dave)
-NSIS Installer (Aaron Hochwimmer)
-Aquatic Plants
-New Fish model
-Piranha model 
-Improved Ducks
-Added Visual Object Trackers (fSpirit)
-Added Object View Windows (fManager, fSpirit, vSpiritHolder)
-Added FullDisplay on most Things (for Object Views)
-Modified fLists to popup Object Views
-Added Cease Button to Tools Menu
-Bug: AFter loading planet, cant pan while paused (fixed)
-Set null handle to 0 instead of -1 (faster to check =0)
-Updated Lists Form
  LockWindowUpdate(lbThings.Handle);
  Can View Things by Double Clicking
  Can Remove Thing Window from Sidebar
  Heal/Kill buttons on Viewer
-Added Birthday to objects
  Removed fAge, kept property but now uses GetAge
-Fixed Save/Load/New Planets
-Fixed Load on Startup
-Displays SplashScreen if updated from older version
-Added 3DAutoShow to UserSettings

0.8.9

Added HeightMap for Heat (Dave and Aaron)
Added AIMatingCreature
Fixed atmosphere lighting
Added AIPosition.DistanceToXPlusY
Fixed Hawk cruising altitude
Improved Populations
Added Community.SaveToFile
Added Community.LoadFromFile
Made Populations and HeightField forms create when user opens
Fixed return to state bug.  Top Reality form now returns to view!
Bug in Populations.show
Bug in HeightField.Free // fixed (?)

0.8.8

Added Duck flocking (Aaron Hochwimmer and Dave)
Added Duck icon (Aaron Hochwimmer)
Added Populations Form (Dave and Aaron)

0.8.7

Converted AIFish into a community creature
Changed default water to 15.0
Changed default height to 5.0

0.8.6

Added AICommunity and AICommunityCreature
Added AIThingReferenceList.CommunityWithRoom
Added VectorToString to cUtilities.pas
Fixed some bugs

0.8.5

Aaron Hochwimmer - Added Tiger :)
Aaron Hochwimmer - Added Duck :) :)

0.8.4

Added Mouse

0.8.3

Fixed iceberg initialization
Fixed some bugs

0.8.2

Fixed Barren planets
Fixed values on New Planet form

0.8.1

Made sun orbit "wobble" so that it will reach poles over time, melting ice
Fixed lightning appearance bug when cloud display is disabled
Added random temperature drop of -0.1 across the map, every round
Stopped icebergs from multiplying rapidly

0.8.0

Added proper iceberg generation

0.7.9

Added Iceberg Separation, growth/melting
Fixed AIThingList.NewThing(Kind, Location)
- this fix also fixed adding custom things from the GUI
- Fixed: Storm Cloud Tool
- Fixed: Bubble and Drain Beacons
Fixed: trees on grass, near desert wouldnt grow

0.7.8

Added Snow
Fixed random asteroids

0.7.7 

Added cloud height to float at 40+Water.  Smaller clouds will float lower than large
clouds.

0.7.6

Added icebergs.

0.7.5

Fixed clouds, so that they float on the atmosphere at height=50.
Added zoom feature to target mode (keys +/-)

0.7.4

Added Wind from Temperature Fluctuations
Clouds no longer move on their own, but move from wind
Added wind to atmospheric acceleration in AIPosition

0.7.3

Added Tides from Moons
Added AIGrid.SuckWater

0.7.2

Added save/loading of events

0.7.1

New Planet partially implemented 
(sometimes hangs, working on it)

0.7.0

Windows Installer

0.6.0

Added physics
Added creatures

0.5.0

Added water

0.4.0 

Added trees
Added clouds
Added mountains

0.3.0

Basic 3D engine created
Added planet
Added suns and moons

0.2.0

Basic 2D engine created


